#include "RaveBase/RaveInterface/rave/Charge.h"
#include "RaveBase/RaveInterface/rave/Vector3D.h"
#include "RaveBase/RaveInterface/rave/Vector6D.h"
#include "RaveBase/RaveInterface/rave/Covariance6D.h"
#include "RaveBase/RaveInterface/rave/PerigeeMomentum3D.h"
#include "RaveBase/RaveInterface/rave/PerigeeState5D.h"
#include "RaveBase/RaveInterface/rave/PerigeeCovariance5D.h"

namespace rave {

/**
 * @class PerigeeToRaveObjects converts from perigee coords to euclidian space.
 *
 * This conversion class is used internally by several data classes to provide
 * their data in perigee parametrization also.
 */
class PerigeeToRaveObjects
{
  public:
    Vector3D convert ( const PerigeeMomentum3D & ) const;
    Vector6D convert ( const PerigeeState5D &, const Charge, const Point3D & referencePoint ) const;
    Covariance6D convert ( const PerigeeCovariance5D & error, const Vector6D & state, const Charge charge ) const;
};

} // namespace rave
