#include "RaveBase/RaveInterface/rave/PerigeeCovariance5D.h"

namespace rave
{

PerigeeCovariance5D::PerigeeCovariance5D (
  float doo, float dot, float dop, float dod, float doz, float dtt,
  float dtp, float dtd, float dtz, float dpp, float dpd, float dpz,
  float ddd, float ddz, float dzz ) :
    PerigeeCovariance3D ( doo, dot, dop, dtt, dtp, dpp ),
    thedod ( dod ), thedoz ( doz ), thedtd ( dtd ), thedtz ( dtz ),
    thedpd ( dpd ), thedpz ( dpz ), theddd ( ddd ), theddz ( ddz ),
    thedzz ( dzz )
{}

PerigeeCovariance5D::PerigeeCovariance5D() :
    PerigeeCovariance3D(),
    thedod ( 0. ), thedoz ( 0. ), thedtd ( 0. ), thedtz ( 0. ),
    thedpd ( 0. ), thedpz ( 0. ), theddd ( 0. ), theddz ( 0. ),
    thedzz ( 0. )
{}

float PerigeeCovariance5D::dod() const
{
  return thedod;
}

float PerigeeCovariance5D::doz() const
{
  return thedoz;
}

float PerigeeCovariance5D::dtd() const
{
  return thedtd;
}

float PerigeeCovariance5D::dtz() const
{
  return thedtz;
}

float PerigeeCovariance5D::dpd() const
{
  return thedpd;
}

float PerigeeCovariance5D::dpz() const
{
  return thedpz;
}

float PerigeeCovariance5D::ddd() const
{
  return theddd;
}

float PerigeeCovariance5D::ddz() const
{
  return theddz;
}

float PerigeeCovariance5D::dzz() const
{
  return thedzz;
}

} // namespace rave
